Scriptname SLPGNActorLib extends Quest

Actor Property PlayerRef Auto
Keyword Property ActorTypeNPC Auto

SLPGN_MCMConfig Property Settings Auto
SLPGNAnimLib Property AnimLib Auto hidden

SexlabFramework property SexLab auto
; This is a quest that has ten different actor aliases. Each one is checked for within the area the game has loaded into view.
; And conditions on each alias are as follows: IsActor = 1, IsCommandedActor = 0, IsDead = 0, HasLoaded3D = 1, GetIsGhost = 0, IsChild = 0, and HasKeyword(SexLabActive) = 0.
; Which these make sure they are an actor, aren't a commanded actor like a thrall or familiar, they are not dead, they are in fact loaded in and around the area, 
; They are not a ghost, they are not a child, and they are not in an active sexlab scene as determined if they have a keyword or not.
Quest Property SLPGNDetectionQuest Auto

SexLabPlayerNecroScript Property Main Auto
Faction Property CurrentCompanionFaction Auto

; Follower/Companion quest to detect nearby Dead (Potential) Followers. Has to be in PotentialCompanionFaction because dead followers sometimes lose their CurrentCompanion faction
Quest Property SLPGNCompanionDetectionQuest Auto 

Actor[] Function SelectActorsToPlay(Actor victim, Actor[] akActorArray) ; this function sifts through valid actors to return an array with actors that will be used to play anims
    ;NOTE: THE ARRAY PASSED INTO SelectActorsToPlay FUNC DOES ***NOT*** INCLUDE PLAYER AS 0 ELEMENT. THEY WILL BE A PART OF THE RETURN ARRAY AS ELEMENT ZERO
    ;declare vars for use later
    log("SelectActorsToPlay has started")
    
    Actor[] actorReturn = new Actor[1]; returned actors
    actorReturn[0] = victim
    Actor[] actorBuffer ; used to temporarily save actors that are still going through checks
    int creatureActorIndex = ActorArrayHasCreatures(akActorArray) ; used to see if we have a creature in the necro list, returns the creatures position, -1 if no creature
    int actorNPCIndex = ActorArrayHasNPCs(akActorArray) ; find if there are humans
    
    If (akActorArray.Find(NONE) == 0) ; no actors   
        log("SelectActorsToPlay has returned with " + actorReturn +  ". Something messed up!")
        return actorReturn  
    EndIf   
    
    ;check if creature is possible first, as you should TOTALLY not want to decide that there should be multiple actors when you haven't verified if there are multiple creature/NPC actors or not, and you havent decided if you want creature actors. 
    ;For this, we default to 100 percent chance of creature necro if there are only creatures passed into our array, as if the array has creatures, and there were no NPCs, then clearly the player wanted to have a chance of seeing creatures commit necrophilia, so we make it 100% if there are only valid creatures around
    If ( ( ( Utility.RandomFloat(0.0,100.0) <= Settings.GetCreatureNecroChance() ) || ( creatureActorIndex == -2 ) ) && creatureActorIndex != -1) 
        log("SelectActorsToPlay has decided we're fucking creatures")
    
        If(creatureActorIndex == -2) ; if we found that all the actors in the array are creatures
            creatureActorIndex = 0 ;just set the index to 0 so that akActorArray.[creatureActorIndex].GetRace() works and grabs the first creature actor's race
        EndIf
    
        actorBuffer = GetSpecificActorsFromArray(akActorArray, akActorArray[creatureActorIndex].GetRace()) ; filter actors into NPCs or same-race creatures, returns at most 4 npcs, as max actors in sexlab anim is 5 (including victim)
        
        If( ( Utility.RandomFloat(0.0,100.0) <= Settings.GetMultipleNecroChance() ) && (actorBuffer.Find(NONE) > 1 || actorBuffer.Find(NONE) < 0) ) ;check for successful multiple chance and if there is more than one actor of the same race
            log("SelectActorsToPlay has decided it's multiple creatures")
            
            actorBuffer = AddActorArraysTogether(actorReturn, actorBuffer) ; this is where we pass in the player (finally)          
            actorReturn = AnimLib.CheckForValidAnims(actorBuffer, Main.GetAnimOptions())
            
            log("SelectActorsToPlay has returned with " + actorReturn)
            return actorReturn      
        ElseIf(actorBuffer.Find(NONE) != 0 ) ;if we fail multiple check, make sure we have an actor we can use      
            log("SelectActorsToPlay has decided it's one creature")
            
            actorReturn = new Actor[2]          
            actorReturn[0] = victim ; this is where we pass in the victim (finally)         
            actorReturn[1] = actorBuffer[0] ; add first available sex actor to return array as second slot
            
            log("SelectActorsToPlay has returned with " + actorReturn)
            return actorReturn ;returns actors. We don't really need to use CheckForValidAnims(), as we already checked, using SexLab.ValidateActor() to see if our actors are valid sex actors with at least one duo animation.
        EndIf       
    ElseIf ( actorNPCIndex != -1); if we fail creature check and have humans    
        log("SelectActorsToPlay has decided we're fucking humans")
        
        actorBuffer = GetSpecificActorsFromArray(akActorArray) ; filter actors into NPCs or same-race creatures, returns at most 4 npcs, as max actors in sexlab anim is 5 (including victim)
        
        If( ( Utility.RandomFloat(0.0,100.0) <= Settings.GetMultipleNecroChance() ) && (actorBuffer.Find(NONE) > 1 || actorBuffer.Find(NONE) < 0) ) ;check for successful multiple chance and if there is more than one actor 
            log("SelectActorsToPlay has decided it's multiple humans")
            
            actorBuffer = AddActorArraysTogether(actorReturn, actorBuffer) ; this is where we pass in the player (finally)          
            actorReturn = AnimLib.CheckForValidAnims(actorBuffer, Main.GetAnimOptions())
            
            log("SelectActorsToPlay has returned with " + actorReturn)
            return actorReturn      
        ElseIf(actorBuffer.Find(NONE) != 0 ) ;if we fail multiple check, make sure we have an actor we can use      
            log("SelectActorsToPlay has decided it's only one human")
            
            actorReturn = new Actor[2]          
            actorReturn[0] = victim ; this is where we pass in the player (finally)     
            actorReturn[1] = actorBuffer[0] ; add first available sex actor to return array as second slot
            
            log("SelectActorsToPlay has returned with " + actorReturn)
            return actorReturn ;returns actors. We don't really need to use CheckForValidAnims(), as we already checked, using SexLab.ValidateActor() to see if our actors are valid sex actors with at least one duo animation.
        EndIf   
    EndIf
    
    log("SelectActorsToPlay has returned, unfortunately with " + actorReturn+ " -- Creature index: "+ creatureActorIndex + " -- Human index: "+ actorNPCIndex)
    return actorReturn ; return actors (which should only be the player if we failed all the checks above.(which it shouldn't really. We already checked for zero NPCs))
EndFunction


; This re-work was not done by me, but rather LittleWhiteNeko on the forums here. 

; Reworked ValidNecroActorCheck, splitting the scanning part into own function so the returned actors can be used for Calm Faction in main script
; The reason Calm function was not working well before is because the Calming function received the already filtered actors from ValidNecroActorCheck, meaning it only calm those who are valid for necro
; This means invalid necro actor(aggressors) such as morally good characters, women if toggled off, or unsupported creatures won't get calmed.
; Although the limit of 10 will cause other actors that is not scanned will be uncalmed as well.

Actor[] Function GetNearbyActors(Actor[] ActorsAround, ReferenceAlias[] Aggressors)
    actorsAround = new Actor[10]    
    SLPGNDetectionQuest.Start()
    
    int i = 0   
    While (i < Aggressors.Length)       
        If(Aggressors[i])           
            actorsAround[i] = Aggressors[i].GetActorReference()         
        EndIf
        i += 1      
    EndWhile
    SLPGNDetectionQuest.Stop()

    return actorsAround
EndFunction



Actor[] Function ValidNecroActorCheck(Actor[] ActorsAround) ;validate necro actors based on MCM settings
    log("ValidNecroActorCheck started the actor check")
    
    Actor[] actorReturn = new Actor[10] 
    
    int i = 0
    
    While (i < actorsAround.Length) 
        If(actorsAround[i]) 
            Bool IsValidNecroActor = ((actorsAround[i].HasKeyword(ActorTypeNPC))||(SexLab.ValidateActor(actorsAround[i]) == 1)) ; this will both filter out any creatures that don't have anims, OR any creatures that do, but creature anims are not allowed in SL
            log("the Sexlab return code on the actor "+ actorsAround[i].GetLeveledActorBase().GetName() +" was "+SexLab.ValidateActor(actorsAround[i]))
        
            If ( (Settings.GetCombatNecro() == 0) && IsValidNecroActor) ;if our combat check is there, and we have a valid actor
                actorsAround[i].GetCombatState()
                IsValidNecroActor = (actorsAround[i].GetCombatState() == 0)
            
                log(actorsAround[i].GetLeveledActorBase().GetName() + " combat check = "+ IsValidNecroActor)
            EndIf
        
            If ( (Settings.GetValidGender() != 2) && actorsAround[i].HasKeyword(ActorTypeNPC) && IsValidNecroActor) ;if our valid gender is not equal to 2, ignoring creatures
                IsValidNecroActor = (actorsAround[i].GetLeveledActorBase().GetSex() == Settings.GetValidGender())           
                log(actorsAround[i].GetLeveledActorBase().GetName() + " gender check = "+ IsValidNecroActor)
            EndIf
        
            If ( (Settings.GetMoralityCheck() == 0) && actorsAround[i].HasKeyword(ActorTypeNPC) && IsValidNecroActor) ;if our morality check is not set to be ignored, and the actor is not a creature 
                IsValidNecroActor = (actorsAround[i].GetAV("Morality") == 0)            
                log(actorsAround[i].GetLeveledActorBase().GetName() + " morality check = "+ IsValidNecroActor)          
            EndIf
        
            If ( ( !Settings.GetCreatureNecro() ) && IsValidNecroActor);check if creatures can't necro, and if returns true, filter out the actor if they are a creature
                IsValidNecroActor = actorsAround[i].HasKeyword(ActorTypeNPC)            
                log(actorsAround[i].GetLeveledActorBase().GetName() + " creature check = "+ IsValidNecroActor)          
            EndIf
    
            If ( IsValidNecroActor ) ; add actor to array if valid              
                int emptySlot = actorReturn.Find(NONE)          
                actorReturn[emptySlot] = actorsAround[i]                
                log(actorsAround[i].GetLeveledActorBase().GetName() + " was valid")         
            EndIf           
        Else        
            log("Slot" + i +" didn't have anyone in it...")         
        EndIf
        
        i += 1      
    EndWhile
    
    log("ValidNecroActorCheck is done and returning array: "+ actorReturn)
    return actorReturn
EndFunction


; Function to get nearby dead followers up to 10 of them for multiple followers compatibility
; Or mostly because I had troubles with Quest scan that I don't want to touch it right now, risking it breaking again
; Note in this the ReferenceAlias is called Followers instead of Comps in main script. I put my reasoning there.
Actor[] Function GetDeadFollowers(Actor[] followersAround, ReferenceAlias[] Followers)
    Actor[] followersReturn = new Actor[10]
    
    followersAround = new Actor[10]
    
    SLPGNCompanionDetectionQuest.Start()
    int i = 0   
    While (i <= Followers.Length)
        If(Followers[i])
            followersAround[i] = Followers[i].GetActorReference()
        EndIf
        
        i += 1      
    EndWhile

    SLPGNCompanionDetectionQuest.Stop()

    i = 0
    
    While (i < followersAround.Length) 
        If(followersAround[i]) 
            If(followersAround[i].HasKeyword(ActorTypeNPC))           
                int emptySlot = followersReturn.Find(NONE)          
                followersReturn[emptySlot] = followersAround[i]                
                log(followersAround[i].GetLeveledActorBase().GetName() + " was valid")         
            EndIf           
        Else        
            log("Slot" + i +" didn't have anyone in it...")         
        EndIf
        
        i += 1      
    EndWhile
    
    return followersReturn

EndFunction


int Function ActorArrayHasCreatures(Actor[] akActorArray) ; Grabs the index of where a creature was found for .GetRace() function. Passes -1 if there is no creature, and if all the actors are creeatures then pass -2 
    int i = 0   
    int index = -1  
    int isCreatureFound = 0 
    int lengthOfRealActorList = akActorArray.Find(NONE) ; make sure we don't try to get NONEs using a real count of the actors we can see
    
    If(lengthOfRealActorList < 0)   
        lengthOfRealActorList = akActorArray.Length 
    EndIf
    
    While (i < lengthOfRealActorList )  
        If(akActorArray[i] && !akActorArray[i].HasKeyword(ActorTypeNPC))        
            isCreatureFound += 1            
        EndIf
        
        If(isCreatureFound == 1)
            index = i       
        EndIf
        
        If(isCreatureFound == lengthOfRealActorList) ; make sure we don't try to get NONEs using a real count of the actors we can see      
            index = -2 ;set us to the code that means all creatures in the array        
        EndIf
        
        i += 1  
    EndWhile
    return index
EndFunction


int Function ActorArrayHasNPCs(Actor[] akActorArray) ; Grabs the index of where an NPC was found. Passes -1 if there is no NPC, and if all the actors are NPCs, then pass -2 
    int i = 0   
    int index = -1  
    int isNPCFound = 0  
    int lengthOfRealActorList = akActorArray.Find(NONE) ; make sure we don't try to get NONEs
    
    If(lengthOfRealActorList < 0)   
        lengthOfRealActorList = akActorArray.Length 
    EndIf
    
    While (i < lengthOfRealActorList )  
        If(akActorArray[i] && akActorArray[i].HasKeyword(ActorTypeNPC))     
            isNPCFound += 1         
        EndIf
        
        If(isNPCFound == 1)
            index = i       
        EndIf
        
        If(isNPCFound == lengthOfRealActorList) ; if we found that all the actors in the array were creatures       
            index = -2 ;set us to the code that means all creatures in the array        
        EndIf       
        i += 1  
    EndWhile
    
    return index
EndFunction


Actor[] Function GetSpecificActorsFromArray(Actor[] akActorArray, Race rCheckingRace = NONE) ; returns all NPCs or all creatures of the same race.
    int i = 0   
    log("GetSpecificActorsFromArray is now starting")
    
    Actor[] actorReturn = new Actor[4]; returned actors 
    If ( rCheckingRace == NONE )    
        While (i < actorReturn.Length)  
            If( akActorArray[i] && akActorArray[i].HasKeyword(ActorTypeNPC) )           
                int emptySlot = actorReturn.Find(NONE)          
                actorReturn[emptySlot] = akActorArray[i]            
            EndIf       
            i += 1  
        EndWhile    
    Else    
        While (i < actorReturn.Length)  
            If( akActorArray[i] && akActorArray[i].GetRace() == rCheckingRace )         
                int emptySlot = actorReturn.Find(NONE)          
                actorReturn[emptySlot] = akActorArray[i]            
            EndIf
        
            i += 1  
        EndWhile    
    EndIf
    
    log("GetSpecificActorsFromArray is now sending back" + actorReturn)
    return actorReturn
EndFunction


; Stuff dealing with the arrays of actors.
Actor[] Function AddActorArraysTogether(Actor[] akActorArray1, Actor[] akActorArray2) ; max of 5 will be passed back 
    log("Started AddActorArraysTogether")

    int i = 0   
    int indexOfReturnArray = 0
    
    Form[] actorBuffer = Utility.CreateFormArray(akActorArray1.Length + akActorArray2.Length); returned actors, using SKSE function, to create a form array 
    While (i < akActorArray1.Length )   
        If (akActorArray1[i])   
            actorBuffer[indexOfReturnArray] = akActorArray1[i]          
            log("Setting "+ indexOfReturnArray +" element of Buffer array")         
        EndIf
        
        i += 1      
        indexOfReturnArray += 1 
    EndWhile
    
    i = 0
    
    While (i < akActorArray2.Length )   
        If (akActorArray2[i])   
            actorBuffer[indexOfReturnArray] = akActorArray2[i]          
            log("Setting "+ indexOfReturnArray +" element of Buffer array")         
        EndIf
        
        i += 1      
        indexOfReturnArray += 1 
    EndWhile
    
    i = 0
    
    Actor[] actorReturn = new Actor[5]  
    While (i < actorReturn.Length ) 
        If (actorBuffer[i] as Actor)    
            actorReturn[i] = (actorBuffer[i] as Actor)          
            log("Setting "+ i +" element of return array")          
        EndIf   
        i += 1          
    EndWhile
    
    log("AddActorArraysTogether is returning " + actorReturn)
        
    return actorReturn
EndFunction


Actor[] Function ShortenActorArray(Actor[] akActorArray, int newLength) ; pass in an actor array to be shortened to a new length
    log("ShortenActorArray has started")
    
    Actor[] actorReturn ; returned actors   
    If (newLength >= akActorArray.Length)   
        return akActorArray 
    EndIf
    
    If (newLength <= 0) 
        return actorReturn  
    EndIf
    
    int i = 0
    
    If(newLength >= 5)
        actorReturn = new Actor[5]
    ElseIf(newLength == 4)
        actorReturn = new Actor[4]
    ElseIf(newLength == 3)
        actorReturn = new Actor[3]
    ElseIf(newLength == 2)
        actorReturn = new Actor[2]
    ElseIf(newLength == 1)
        actorReturn = new Actor[1]
    EndIf
    
    While (i < newLength )
        actorReturn[i] = akActorArray[i]        
        i += 1  
    EndWhile
    
    log("ShortenActorArray done. Returning " + actorReturn)
    return actorReturn
EndFunction


Function LoadLibraries()
    Form SLPGNQuest = Game.GetFormFromFile(0xD62, "SLPGN.esp")
    Log("Loading Libraries...")
    If(SLPGNQuest)
        Settings = Game.GetFormFromFile(0x22ED, "SLPGN.esp") as SLPGN_MCMConfig
        AnimLib = SLPGNQuest as SLPGNAnimLib
    EndIf
EndFunction


Function log(String argString)
    Debug.Trace("SLPGN Actor Library: " + Utility.GetCurrentRealTime()+ " -- " + argString )    
EndFunction
