Scriptname SLPGNAnimLib extends Quest

Actor Property PlayerRef Auto
Keyword Property ActorTypeNPC Auto
SLPGN_MCMConfig Property Settings Auto

SexlabFramework property SexLab auto
SLPGNActorLib property ActorLib auto


sslBaseAnimation[] Function SetNecroAnims(Actor[] akActorArray, String[] animOptions) ;depending on who's in the array and what type they are, get anims and return
    sslBaseAnimation[] animsReturn  
    Bool isCreatureAnimation = !akActorArray[1].HasKeyword(ActorTypeNPC) ;assumes aggressor is second actor in array
    
    If (isCreatureAnimation)
        animsReturn = SexLab.GetCreatureAnimationsByRaceTags(akActorArray.Length, akActorArray[1].GetRace(), animOptions[0], "")
        if (animsReturn.Length == 0)
            animsReturn = Sexlab.GetCreatureAnimationsByRaceTags(akActorArray.Length, akActorArray[1].GetRace(), "Rough", "")   
        EndIf
    Else        
        string genderTag = "F" + SexLab.GetGenderTag(0,akActorArray.Length - 1) 
        animsReturn = Sexlab.GetAnimationsByTags(akActorArray.Length, animOptions[1]+genderTag)
    EndIf
    return animsReturn  
EndFunction


Actor[] Function CheckForValidAnims(Actor[] akActorArray, String[] animOptions) ; checks for a valid amount of actor animations. ASSUMES THAT ACTORS IN akActorArray AFTER THE FIRST ELEMENT ARE ALL SAME TYPE (NPC or Creature). This function should only recieve 5 element arrays
    Actor[] actorReturn ; returned actors
    
    log("CheckForValidAnims is running with array of "+ akActorArray)

    int filledActorArrayLength  ;Find(NONE) function is useful for this script, as we fill our arrays from element 0 to the max length, so we should have only void elements after we find the first one, and the first void element's index is technically the number of actors in the array
    
    If (akActorArray.Find(NONE) == 2) ; if we already only have 2, we return immediately, as we already have enough actors for sex anims, and actors passed in should have already been valid
        actorReturn = new Actor[2]      
        actorReturn[0] = akActorArray[0]
        actorReturn[1] = akActorArray[1]
        log("CheckForValidAnims is returning the following because we only had 2 actors: "+ actorReturn)
        
        return actorReturn  
    ElseIf (akActorArray.Find(NONE) == 1) ; if we have less than 2 somehow, we return immediately an actor array of only the player. Later on, the script checks for failure and will not necro the player
        actorReturn = new Actor[1]      
        actorReturn[0] = akActorArray[0]
        
        log("CheckForValidAnims is returning the following because we only had 1 actor: "+ actorReturn) 
        
        return actorReturn  
    ElseIf ( akActorArray.Find(NONE) > 2) ;     
        filledActorArrayLength = akActorArray.Find(NONE); use Find(NONE) to find where to start in the index if the actor array wasn't fully filled
        log("CheckForValidAnims filledActorArrayLength is : "+ filledActorArrayLength)      
    Else    
        filledActorArrayLength = akActorArray.Length; otherwise, the only option left is saying that all slots are filled, so just use the array's length of 5
        log("CheckForValidAnims argument akActorArray was full of actors")  
    EndIf   
    
    bool isCreatureAggressor = !akActorArray[1].HasKeyword(ActorTypeNPC) ; if the array of possible sex actors has a creature after the victim slot of the array
    sslBaseAnimation[] animsCheck ; buffer anims array where we check if there are any anims for the group sex that we can have 
    int i = 0
    
    If (isCreatureAggressor)    
        While (i < filledActorArrayLength )         
            actorReturn = ActorLib.ShortenActorArray(akActorArray,( filledActorArrayLength - i )) ; use this function to determine the actors we can have
            
            If (actorReturn.Find(NONE) < 0)     
                animsCheck = SexLab.GetCreatureAnimationsByRaceTags(actorReturn.Length, actorReturn[1].GetRace(), "Necro,Guro,Snuff,Sleeping", "", false)
                if (animsCheck.Length == 0)
                    animsCheck = Sexlab.GetCreatureAnimationsByRaceTags(actorReturn.Length, actorReturn[1].GetRace(), "Rough,Aggressive,Agressive", "", false)  
                EndIf
            Else ; if the array isn't completely filled 
                animsCheck = SexLab.GetCreatureAnimationsByRaceTags(actorReturn.Find(NONE), actorReturn[1].GetRace(), "Necro,Guro,Snuff,Sleeping", "", false)
                if (animsCheck.Length == 0)
                    animsCheck = Sexlab.GetCreatureAnimationsByRaceTags(actorReturn.Find(NONE), actorReturn[1].GetRace(), "Rough,Aggressive,Agressive", "", false)  
                EndIf       
            EndIf
            
            If(animsCheck.Length > 0) ; if we have animations           
                log("CheckForValidAnims found valid creature anims on check. The array return looks like this: "+ actorReturn)
                return actorReturn ; return the current actors that are viable          
            EndIf
            
            log("CheckForValidAnims found no valid creature anims on check. The return array looks like this: "+ actorReturn)
            
            i += 1  
        EndWhile    
    Else    
        While (i < filledActorArrayLength )
            actorReturn = ActorLib.ShortenActorArray(akActorArray,( filledActorArrayLength - i )); use this function to determine the actors we can have
            string genderTag = "F" 
            
            string[] tags = new string[4]
            tags[0] = animOptions[0]
            tags[1] = "Guro"
            tags[2] = "Snuff"
            tags[3] = "Sleeping"
            
            If (actorReturn.Find(NONE) < 0) ; if all of the array is filled         
                genderTag = genderTag + SexLab.GetGenderTag(0,actorReturn.Length - 1)
                
                int x = 0;
                While (x < 4)
                    sslBaseAnimation[] tagAnims = SexLab.GetAnimationsByTag(actorReturn.Length, tags[x]+","+genderTag) ; get anims, if any. 
                    animsCheck = SexLab.MergeAnimationLists(tagAnims, animsCheck)
                    x+=1
                EndWhile        
            Else ; if the array isn't completely filled         
                genderTag = genderTag + SexLab.GetGenderTag(0,actorReturn.Find(NONE) - 1)
                
                int x = 0;
                While (x < 4)
                    sslBaseAnimation[] tagAnims = SexLab.GetAnimationsByTag(actorReturn.Length, tags[x]+","+genderTag, "Cowgirl") ; get anims, if any.  
                    animsCheck = SexLab.MergeAnimationLists(tagAnims, animsCheck)
                    x+=1
                EndWhile                    
            EndIf
            
            If(animsCheck.Length > 0); if we have animations, return the current actors that are viable         
                log("CheckForValidAnims found valid necros anims on check. The array return looks like this: "+ actorReturn)
                return actorReturn          
            EndIf
            
            log("CheckForValidAnims no found valid necro anims on check. The array return looks like this: "+ actorReturn)
            
            i += 1  
        EndWhile        
    EndIf
    
    return actorReturn; return blank actors because wat. We should have some actors based on our previous checks!
EndFunction


String[] Function CheckAnimOption(String[] animOptions)
    ; Yet another null check because I do not trust the game nor Papyrus enough.
    If(animOptions.Length == 0)
        animOptions = new string [2]
    EndIf

    int option = Settings.GetAnimOption()

    If(option == 0)
        animOptions[0] = "Necro"
        animOptions[1] = "Necro,"

    ElseIf(option == 1)
        animOptions[0] = "Aggressive"
        animOptions[1] = "Aggressive,"
    Else
        ; Nothing right now.
    EndIf
    return animOptions
EndFunction


Function LoadLibraries()
    Form SLPGNQuest = Game.GetFormFromFile(0xD62, "SLPGN.esp")
    Log("Loading Libraries...")
    If(SLPGNQuest)
        Settings = Game.GetFormFromFile(0x22ED, "SLPGN.esp") as SLPGN_MCMConfig
        ActorLib = SLPGNQuest as SLPGNActorLib
    EndIf
EndFunction


;------------------------------------ Debug Stuff -----------------------------
Function log(String argString)
    Debug.Trace("SLPGN Anim Lib: " + Utility.GetCurrentRealTime()+ " -- " + argString ) 
EndFunction

