scriptname SLPGN_MCMConfig extends SKI_ConfigBase 

SexLabPlayerNecroScript Property Main Auto
SLPGNUtils Property Utils Auto

; SCRIPT VERSION ----------------------------------------------------------------------------------

int function GetVersion()
    return 1 ; Default version
endFunction

; Some things are commented out for future usage, once I figure out how to utilize the aspects needed to make the things happen.
; I don't want to add the option to use them if they don't even work, or no functionality is there after all.
; this file, while large does one primary job. Which is dealing with the configuration menu.
; PRIVATE VARIABLES -------------------------------------------------------------------------------


; OIDs (T:Text B:Toggle S:Slider M:Menu, C:Color, K:Key, I:Input) (int)
int B_OID_ModEnabled
int B_OID_AfterEnabled
int B_OID_CreatureNecro
;Int B_OID_KillerOnly
int B_OID_HandleFollowers
int B_OID_KillFollowers
int B_OID_CombatNecro
int B_OID_WetandColdEffects
int B_OID_ToggleLights
int B_OID_ToggleMenus
int B_OID_DoFadeOut
int B_OID_EBTNoBlood
int B_OID_DeflateOnDeath
int B_OID_DeflateWhenFull
int B_OID_UseOldResurrection
int B_OID_PostNecroInstantKill
;int B_OID_ToggleBlinking
;int B_OID_SaveforLater
;int B_OID_HandleBeheading
;int B_OID_MilkEconomy
;int B_OID_LoreFriendlyResurrection
int B_OID_ToggleFreeCam
int B_OID_ToggleExpression
int B_OID_ToggleExpressionLoad

int M_OID_ValidGender
int M_OID_MoralityCheck
int M_OID_AnimOptionList

int S_OID_NecroChance
int S_OID_CreatureNecroChance
int S_OID_MultipleNecroChance
int S_OID_StartScanningTime
int S_OID_EndScanningTime
int S_OID_KillWaitTime
int S_OID_KillChance
int S_OID_PostResWait
int S_OID_DeathCamDuration

; Internal variables
string[] validGenderList
string[] moralityCheckList
string[] animTagsOptionsList

Bool modEnabled = true 
Bool creatureNecro = false
Bool combatNecro = false
;Bool KillerOnly = false
Bool handleFollowers = false
Bool killFollowers = true
Bool wetColdEffects = false
Bool toggleLights = false
Bool toggleMenus = false
Bool doFadeOut = false
Bool noBloodPools = false
Bool deflateOnDeath = false
Bool deflateWhenFull = false
Bool useOldResurrection = false 
Bool postNecroInstantKill = false 
Bool toggleFreeCam = true
;Bool toggleBlinking = true
;Bool decorate = false 
;Bool handleBeheading = true
;Bool MilkMod = false
;Bool loreResurrection = false 

int moralityCheckDefault = 0
int moralityCheck = 0; 0 = immoral peeps only, 1 = anybody can be necrophilic (weird people, eh?)
int validGenderDefault = 0
int validGender = 0; 0 = males only, 1 = females only, 2 = both
int animOption = 0 
int animOptionDefault = 0 

float necroChanceDefault = 50.0
float necroChance = 50.0; percentage chance of dem necrophiliacs getting some
float creatureNecroChanceDefault = 20.0
float creatureNecroChance = 20.0; percentage chance of dem necrophiliacs being creatures
float multipleNecroChanceDefault = 25.0
float multipleNecroChance = 25.0; percentage chance of dem multiple necrophilics getting some at the same time
float deathCamDuration = 120.0
float deathCamDurationDefault = 120.0
;float decorationChance = 0.0
;float decorationChanceDefault = 0.0
int scanStartTimeDefault = 10
int scanStartTime = 10; How long after death to start scanning for the player's body.
int scanEndTimeDefault = 30
int scanEndTime = 30 ; How long after death to end scanning. The start and end time are used as the low and high end to generate a time to wait before checking again.
int killWaitTime = 5 ; How long the script waits before issuing the command to kill the player.
int KillChance = 50
float PostResWait = 30.0

; Expression Variables
bool enableExpression = true
Bool Property MFGLoad_B = False Auto
float Property SgtmFloat Auto
int[] Property MfgExpression Auto
int[] Property MfgModifierStrength Auto
int[] Property MfgPhonemeStrength Auto
string[]    _modifierNames
string[]    _phonemeNames
string[]    _expressionNames

event OnVersionUpdate(int a_version)
    OnConfigInit()
endEvent


; @implements SKI_ConfigBase
event OnConfigInit()
    {Called when this config menu is initialized}
    
    Pages = new string[4]
    Pages[0] = "$SLPGN_MainMenu"
    Pages[1] = "$SLPGN_FollowerMenu"
    Pages[2] = "$SLPGN_AdditionalMenu"
    Pages[3] = "$SLPGN_ExpressionMenu"
    
    validGenderList = new string[3]
    validGenderList[0] = "$SLPGN_GenderCheckMalesOnly"
    validGenderList[1] = "$SLPGN_GenderCheckFemalesOnly"
    validGenderList[2] = "$SLPGN_GenderCheckBoth"
    
    moralityCheckList = new string[2]
    moralityCheckList[0] = "$SLPGN_MoralityCheckImmoral"
    moralityCheckList[1] = "$SLPGN_MoralityCheckBoth"

    animTagsOptionsList = new string [2]
    animTagsOptionsList[0] = "$SLPGN_AnimOptionOne"
    animTagsOptionsList[1] = "$SLPGN_AnimOptionTwo"
    
    ; Expression Configuration -------------------------------------------
    MfgPhonemeStrength = new int[128]
    MfgModifierStrength = new int[128]
    MfgExpression = new int[32]
    SgtmFloat = 0.25
    _phonemeNames = new string[16]
    _modifierNames = new string[16]
    _expressionNames = new string[17]
    _phonemeNames[0] = "Aah"
    _phonemeNames[1] = "BigAah"
    _phonemeNames[2] = "BMP"
    _phonemeNames[3] = "ChJSh"
    _phonemeNames[4] = "DST"
    _phonemeNames[5] = "Eee"
    _phonemeNames[6] = "Eh"
    _phonemeNames[7] = "FV"
    _phonemeNames[8] = "I"
    _phonemeNames[9] = "K"
    _phonemeNames[10] = "N"
    _phonemeNames[11] = "Oh"
    _phonemeNames[12] = "OohQ"
    _phonemeNames[13] = "R"
    _phonemeNames[14] = "Th"
    _phonemeNames[15] = "W"
    _modifierNames[0] = "BlinkLeft"
    _modifierNames[1] = "BlinkRight"
    _modifierNames[2] = "BrowDownLeft"
    _modifierNames[3] = "BrowDownRight"
    _modifierNames[4] = "BrowInLeft"
    _modifierNames[5] = "BrowInRight"
    _modifierNames[6] = "BrowUpLeft"
    _modifierNames[7] = "BrowUpRight"
    _modifierNames[8] = "LookDown"
    _modifierNames[9] = "LookLeft"
    _modifierNames[10] = "LookRight"
    _modifierNames[11] = "LookUp"
    _modifierNames[12] = "SquintLeft"
    _modifierNames[13] = "SquintRight"  
    _modifierNames[14] = "HeadPitch(Broken)"
    _modifierNames[15] = "HeadRoll(Broken)"
    _expressionNames[0] = "Dialogue Anger"
    _expressionNames[1] = "Dialogue Fear"
    _expressionNames[2] = "Dialogue Happy"
    _expressionNames[3] = "Dialogue Sad"
    _expressionNames[4] = "Dialogue Surprise"
    _expressionNames[5] = "Dialogue Puzzled"
    _expressionNames[6] = "Dialogue Disgusted"
    _expressionNames[7] = "Mood Neutral"
    _expressionNames[8] = "Mood Anger"
    _expressionNames[9] = "Mood Fear"
    _expressionNames[10] = "Mood Happy"
    _expressionNames[11] = "Mood Sad"
    _expressionNames[12] = "Mood Surprise"
    _expressionNames[13] = "Mood Puzzled"
    _expressionNames[14] = "Mood Disgusted"
    _expressionNames[15] = "Combat Anger"
    _expressionNames[16] = "Combat Shout"
    
    ; Default Expression
    MfgModifierStrength[0] = 100
    MfgModifierStrength[1] = 100
endEvent


; EVENTS ------------------------------------------------------------------------------------------

; @implements SKI_ConfigBase, Called when a new page is selected, including the initial empty page.
event OnPageReset(string a_page)
    If (a_page == "")   
        ; Image size 
        ; X offset = 376 - (512 / 2) = 120
        ; Y offset = 223 - (512 / 2) = -23
        LoadCustomContent("SLPGN/res/SLPGN_logo.dds", 120, -33)
        return
    Else
        UnloadCustomContent()   
    EndIf
    
    If (a_page == "$SLPGN_MainMenu")
        SetCursorFillMode(TOP_TO_BOTTOM)
    
        AddHeaderOption("$SLPGN_ModEnabled")
        B_OID_ModEnabled = AddToggleOption("$SLPGN_ModEnabledText", modEnabled)
        AddEmptyOption()
        
        AddHeaderOption("$SLPGN_ActorOptions")
        B_OID_CreatureNecro = AddToggleOption("$SLPGN_CreatureNecroText", creatureNecro)
        B_OID_CombatNecro = AddToggleOption("$SLPGN_CombatNecroText", combatNecro)
;       B_OID_KillerOnly = AddToggleOption("$SLPGN_KillerOnlyText", KillerOnly)
;        B_OID_HandleFollowers = AddToggleOption("$SLPGN_HandleFollowersText", handleFollowers)
        M_OID_ValidGender = AddMenuOption("$SLPGN_GenderCheckText", validGenderList[validGender])
        M_OID_MoralityCheck = AddMenuOption("$SLPGN_MoralityCheckText", moralityCheckList[moralityCheck])

        AddHeaderOption("$SLPGN_AnimHeader")
        M_OID_AnimOptionList = AddMenuOption("$SLPGN_AnimOptionsListText", animTagsOptionsList[animOption])
        SetCursorPosition(1)
        
        AddHeaderOption("$SLPGN_ChanceOptions")
        S_OID_NecroChance = AddSliderOption("$SLPGN_NecroChanceText", necroChance)
        S_OID_CreatureNecroChance = AddSliderOption("$SLPGN_CreatureChanceText", creatureNecroChance)
        S_OID_MultipleNecroChance = AddSliderOption("$SLPGN_MultipleChanceText", multipleNecroChance)
        
        AddEmptyOption()
        AddHeaderOption("$SLPGN_TimeSetting")
        If(!main.GetDeathCamPresent())
            S_OID_DeathCamDuration = AddSliderOption("$SLPGN_DeathCamText", deathCamDuration)
        EndIf
        S_OID_StartScanningTime = AddSliderOption("$SLPGN_ScanStartText", scanStartTime)
        S_OID_EndScanningTime = AddSliderOption("$SLPGN_ScanEndText", scanEndTime)
        S_OID_KillWaitTime = AddSliderOption("$SLPGN_KillTimeText", killWaitTime)
        S_OID_KillChance = AddSliderOption("$SLPGN_KillChanceText", KillChance)
        S_OID_PostResWait = AddSliderOption("$SLPGN_PostResWaitText", PostResWait)
        
    ElseIf(a_page == "$SLPGN_FollowerMenu")
        B_OID_HandleFollowers = AddToggleOption("$SLPGN_HandleFollowersText", handleFollowers)
        AddEmptyOption()
        B_OID_KillFollowers = AddToggleOption("$SLPGN_KillFollowersText", killFollowers)
    ElseIf(a_page == "$SLPGN_AdditionalMenu")
        SetCursorFillMode(TOP_TO_BOTTOM)
        AddHeaderOption("$SLPGN_Toggles")
        B_OID_WetandColdEffects = AddToggleOption("$SLPGN_WnCEffectsText", wetColdEffects)
;       B_OID_ToggleLights = AddToggleOption("$SLPGN_LightEffectsText", toggleLights)
        B_OID_ToggleMenus = AddToggleOption("$SLPGN_ToggleMenusText", toggleMenus)
        B_OID_EBTNoBlood = AddToggleOption("$SLPGN_EBTNoBloodText", noBloodPools)
        B_OID_DoFadeOut = AddToggleOption("$SLPGN_FadeOutText", doFadeOut)
        B_OID_UseOldResurrection      = AddToggleOption("$SLPGN_OldResurrectText", useOldResurrection) ; Remove once the resurrection is functional.
        B_OID_PostNecroInstantKill = AddToggleOption("$SLPGN_PostNecroInstantKillText", postNecroInstantKill)
;       B_OID_ToggleBlinking = AddToggleOption("$SLPGN_ToggleBlinkText", toggleBlinking)
;       B_OID_HandleBeheading = AddToggleOption("$SLPGN_HandleBeheadingText", handleBeheading)
;       B_OID_MilkEconomy = AddToggleOption("$SLPGN_MilkModText", MilkMod)
        B_OID_ToggleFreeCam = AddToggleOption("$SLPGN_ToggleFreeCamText", toggleFreeCam)

        AddEmptyOption()
        AddHeaderOption("$SLPGN_FHUHeader")
        B_OID_DeflateOnDeath = AddToggleOption("$SLPGN_DeflateOnDeathText", deflateOnDeath)
        B_OID_DeflateWhenFull = AddToggleOption("$SLPGN_DeflateWhenFullText", deflateWhenFull)

;       AddEmptyOption()
;       AddHeaderOption("$SLPGN_ResurrectionOptions")
;       S_OID_KillChance = AddSliderOption("$SLPGN_KillChanceText", KillChance) ; Remove the earlier occurance of this once this code is put into production.
;       B_OID_LoreFriendlyResurrection = AddToggleOption("$SLPGN_LoreResurrectText", loreResurrection)
;       B_OID_UseOldResurrection = AddToggleOption("$SLPGN_OldResurrectText", useOldResurrection) ; Remove the earlier occurance of this once this code is put into production.


;       AddEmptyOption()
;       AddHeaderOption("$SLPGN_PostNecroOptionsHeader")
;       B_OID_Decoration = AddToggleOption("$SLPGN_DecorationText", decorate)

    ElseIf(a_page == "$SLPGN_ExpressionMenu")
        SetCursorFillMode(LEFT_TO_RIGHT)
        B_OID_ToggleExpression = AddToggleOption("$SLPGN_ToggleExpressionText", enableExpression)
        B_OID_ToggleExpressionLoad = AddToggleOption("$SLPGN_SaveExpressionText", MFGLoad_B)
        
        AddEmptyOption()
        AddEmptyOption()
        
        int x = 0
        while(x < 16)
            AddTextOption("Phoneme "+ x+"  "+  _phonemeNames[x] +": ", MfgPhonemeStrength[x])
            AddTextOption("Modifier "+ x + "  " + _modifierNames[x]+": ", MfgModifierStrength[x])
            x += 1
        endWhile
        
        int y = 0
        while(y < 16)
            AddTextOption("Expression "+ y+"  "+  _expressionNames[y] +": ", MfgExpression[y])
            y += 1
        endWhile
    EndIf
endEvent


; @implements SKI_ConfigBase, Called when a non-interactive option has been selected.
event OnOptionSelect(int a_option)
    If(a_option == B_OID_ModEnabled)
        modEnabled = !modEnabled
        SetToggleOptionValue(a_option, modEnabled)
    EndIf
    
    If(a_option == B_OID_CombatNecro)
        combatNecro = !combatNecro
        SetToggleOptionValue(a_option, combatNecro)
    EndIf
    
    If(a_option == B_OID_CreatureNecro)
        creatureNecro = !creatureNecro
        SetToggleOptionValue(a_option, creatureNecro)   
    EndIf

;   If(a_option == B_OID_KillerOnly)
;       KillerOnly != KillerOnly
;       SetToggleOptionValue(a_option, KillerOnly)
;   EndIf

    If(a_option == B_OID_HandleFollowers)
        handleFollowers = !handleFollowers
        SetToggleOptionValue(a_option, handleFollowers)
    EndIf
    
    If(a_option == B_OID_KillFollowers)
        killFollowers = !killFollowers
        SetToggleOptionValue(a_option, killFollowers)
    EndIf

    If(a_option == B_OID_WetandColdEffects)
        wetColdEffects = !wetColdEffects
        SetToggleOptionValue(a_option, wetColdEffects)
    EndIf

;   If(a_option == B_OID_ToggleLights)
;       toggleLights = !toggleLights
;       SetToggleOptionValue(a_option, toggleLights)
;   EndIf

    If(a_option == B_OID_ToggleMenus)
        toggleMenus = !toggleMenus
        SetToggleOptionValue(a_option, toggleMenus)
    EndIf

    If(a_option == B_OID_EBTNoBlood)
        noBloodPools = !noBloodPools
        SetToggleOptionValue(a_option, noBloodPools)
    EndIf

    If(a_option == B_OID_DoFadeOut)
        doFadeOut = !doFadeOut
        SetToggleOptionValue(a_option, doFadeOut)
    EndIf

    If(a_option == B_OID_UseOldResurrection)
        useOldResurrection = !useOldResurrection
        SetToggleOptionValue(a_option, useOldResurrection)
    EndIf
    
    If(a_option == B_OID_PostNecroInstantKill)
        postNecroInstantKill = !postNecroInstantKill
        If(postNecroInstantKill)
            Debug.MessageBox("Enabling this disables Post Necro Resurrection (100% Death chance) and Death Timer")
        EndIf
        SetToggleOptionValue(a_option, postNecroInstantKill)
    EndIf

    If(a_option == B_OID_DeflateOnDeath)
        deflateOnDeath = !deflateOnDeath
        SetToggleOptionValue(a_option, deflateOnDeath)
    EndIf

    If(a_option == B_OID_DeflateWhenFull)
        deflateWhenFull = !deflateWhenFull
        SetToggleOptionValue(a_option, deflateWhenFull)
    EndIf
    
    If(a_option == B_OID_ToggleFreeCam)
        toggleFreeCam = !toggleFreeCam
        SetToggleOptionValue(a_option, toggleFreeCam)
    EndIf

;   If(a_option == B_OID_ToggleBlinking)
;       toggleBlinking = !toggleBlinking
;       SetToggleOptionValue(a_option, toggleBlinking)
;   EndIf

;   If(a_option == B_OID_MilkEconomy)
;       MilkMod = !MilkMod
;       SetToggleValue(a_option, MilkMod)
;   EndIf

;   If(a_option == B_OID_LoreFriendlyResurrection)
;       loreResurrection = !loreResurrection
;       SetToggleOptionValue(a_option, loreResurrection)
;   EndIf

    if (a_option == B_OID_ToggleExpression)
        enableExpression = !enableExpression
        SetToggleOptionValue(B_OID_ToggleExpression, enableExpression)
    endIf

    if (a_option == B_OID_ToggleExpressionLoad)
        MFGLoad_B = False
        MFGGet()
        ShowMessage("Current MFG Expression saved")
        SetToggleOptionValue(B_OID_ToggleExpressionLoad, MFGLoad_B)
        ForcePageReset()
    endIf
endEvent



; @implements SKI_ConfigBase, Used when an option is highlighted.
event OnOptionHighlight(int a_option)
    If(a_option == B_OID_ModEnabled)
        SetInfoText("$SLPGN_ModEnabledInfo")
    EndIf
    
    If(a_option == B_OID_CreatureNecro)
        SetInfoText("$SLPGN_CreatureNecroInfo")
    EndIf
    
    If(a_option == B_OID_CombatNecro)
        SetInfoText("$SLPGN_CombatNecroInfo")
    EndIf

;   If(a_option == B_OID_KillerOnly)
;       SetInfoText("$SLPGN_KillerOnlyInfo")
;   EndIf

    If(a_option == B_OID_HandleFollowers)
        SetInfoText("$SLPGN_HandleFollowerInfo")
    EndIf
    
    If(a_option == B_OID_KillFollowers)
        SetInfoText("$SLPGN_KillFollowersInfo")
    EndIf
    
    If(a_option == B_OID_WetandColdEffects)
        SetInfoText("$SLPGN_WnCEffectsInfo")
    EndIf

;   If(a_option == B_OID_ToggleLights)
;       SetInfoText("$SLPGN_LightEffectsInfo")
;   EndIf

    If(a_option == B_OID_ToggleMenus)
        SetInfoText("$SLPGN_ToggleMenusInfo")
    EndIf

    If(a_option == B_OID_EBTNoBlood)
        SetInfoText("$SLPGN_EBTNoBloodInfo")
    EndIf

    If(a_option == B_OID_DoFadeOut)
        SetInfoText("$SLPGN_FadeOutInfo")
    EndIf

    If(a_option == B_OID_UseOldResurrection)
        SetInfoText("$SLPGN_OldResurrectInfo")
    EndIf
    
    If(a_option == B_OID_PostNecroInstantKill)
        SetInfoText("$SLPGN_PostNecroInstantKillInfo")
    EndIf

    If(a_option == B_OID_DeflateOnDeath)
        SetInfoText("$SLPGN_DeflateOnDeathInfo")
    EndIf

    If(a_option == B_OID_DeflateWhenFull)
        SetInfoText("$SLPGN_DeflateWhenFullInfo")
    EndIf
    
    If(a_option == B_OID_ToggleFreeCam)
        SetInfoText("$SLPGN_ToggleFreeCamInfo")
    EndIf

;   If(a_option == B_OID_MilkEconomy)
;       SetInfoText("$SLPGN_MilkModInfo")
;   EndIf

;   If(a_option == B_OID_ToggleBlinking)
;       SetInfoText("$SLPGN_ToggleBlinkInfo")
;   EndIf

;   If(a_option == B_OID_LoreFriendlyResurrection)
;       SetInfoText("$SLPGN_LoreResurrectInfo")
;   EndIf

    If(a_option == S_OID_NecroChance)
        SetInfoText("$SLPGN_NecroChanceInfo")
    EndIf
    
    If(a_option == S_OID_CreatureNecroChance)
        SetInfoText("$SLPGN_CreatureChanceInfo")
    EndIf
    
    If( a_option == S_OID_MultipleNecroChance)
        SetInfoText("$SLPGN_MultipleChanceInfo")
    EndIf

    If(a_option == S_OID_DeathCamDuration)
        SetInfoText("$SLPGN_DeathCamInfo")
    EndIf
    
    If( a_option == S_OID_StartScanningTime)
        SetInfoText("$SLPGN_ScanStartInfo")
    EndIf
    
    If( a_option == S_OID_EndScanningTime)
        SetInfoText("$SLPGN_ScanEndInfo")
    EndIf
    
    If(a_option == S_OID_KillWaitTime)
        SetInfoText("$SLPGN_KillTimeInfo")
    EndIf

    If(a_option == S_OID_KillChance)
        SetInfoText("$SLPGN_KillChanceInfo")
    EndIf

    If(a_option == S_OID_PostResWait)
        SetInfoText("$SLPGN_PostResWaitInfo")
    EndIf
    
    If(a_option == M_OID_ValidGender)
        SetInfoText("$SLPGN_GenderCheckInfo")
    EndIf
    
    If(a_option == M_OID_MoralityCheck)
        SetInfoText("$SLPGN_MoralityCheckInfo") 
    EndIf

    If(a_option == M_OID_AnimOptionList)
        SetInfoText("$SLPGN_AnimOptionsListInfo")
    EndIf
    
    If(a_option == M_OID_AnimOptionList)
        SetInfoText("$SLPGN_AnimOptionsListInfo")
    EndIf
    
    If(a_option == B_OID_ToggleExpression)
        SetInfoText("$SLPGN_ToggleExpressionInfo")
    EndIf
    
    If(a_option == B_OID_ToggleExpressionLoad)
        SetInfoText("$SLPGN_SaveExpressionText")
    EndIf
endEvent


; @implements SKI_ConfigBase, Called when a slider option has been selected.
event OnOptionSliderOpen(int a_option)  
    If( a_option == S_OID_NecroChance)
        SetSliderDialogRange(0.0, 100.0)
        SetSliderDialogStartValue(necroChance)
    EndIf
    
    If( a_option == S_OID_CreatureNecroChance)
        SetSliderDialogRange(0.0, 100.0)
        SetSliderDialogStartValue(creatureNecroChance)
    EndIf
    
    If( a_option == S_OID_MultipleNecroChance)
        SetSliderDialogRange(0.0, 100.0)
        SetSliderDialogStartValue(multipleNecroChance)
    EndIf

    If(a_option == S_OID_DeathCamDuration)
        SetSliderDialogRange(1.0, 3600.0)
        SetSliderDialogStartValue(deathCamDuration)
    EndIf

    If( a_option == S_OID_StartScanningTime)
        SetSliderDialogRange(10.0, 290.0)
        SetSliderDialogStartValue(scanStartTime)
    EndIf
    
    If( a_option == S_OID_EndScanningTime)
        SetSliderDialogRange(20.0, 300.0)
        SetSliderDialogStartValue(scanEndTime)
    EndIf
    
    If(a_option == S_OID_KillWaitTime)
        SetSliderDialogRange(0.0, 600.0)
        SetSliderDialogStartValue(killWaitTime)
    EndIf

    If(a_option == S_OID_KillChance)
        SetSliderDialogRange(0.0, 100.0)
        SetSliderDialogStartValue(KillChance)
    EndIf

    If(a_option == S_OID_PostResWait)
        SetSliderDialogRange(0.0, 600.0)
        SetSliderDialogStartValue(PostResWait)
    EndIf
endEvent


; @implements SKI_ConfigBase, Called when a new slider value has been accepted.
event OnOptionSliderAccept(int a_option, float a_value)
    If( a_option == S_OID_NecroChance)
        necroChance = a_value
        SetSliderOptionValue(a_option, a_value)
    EndIf
    
    If( a_option == S_OID_CreatureNecroChance)
        creatureNecroChance = a_value
        SetSliderOptionValue(a_option, a_value)
    EndIf

    If( a_option == S_OID_MultipleNecroChance)
        multipleNecroChance = a_value
        SetSliderOptionValue(a_option, a_value)
    EndIf

    If(a_option == S_OID_DeathCamDuration)
        deathCamDuration = a_value
        SetSliderOptionValue(a_option, a_value)
        main.ApplyDeathCamTime()
    EndIf

    If( a_option == S_OID_StartScanningTime)
        scanStartTime = a_value as int
        SetSliderOptionValue(a_option, a_value)
    EndIf
    
    If( a_option == S_OID_EndScanningTime)
        scanEndTime = a_value as int
        SetSliderOptionValue(a_option, a_value)
    EndIf
    
    If(a_option == S_OID_KillWaitTime)
        killWaitTime = a_value as int
        SetSliderOptionValue(a_option, a_value)
    EndIf

    If(a_option == S_OID_KillChance)
        KillChance = a_value as int
        SetSliderOptionValue(a_option, a_value)
    EndIf

    If(a_option == S_OID_PostResWait)
        PostResWait = a_value
        SetSliderOptionValue(a_option, a_value)
    EndIf
endEvent


event OnOptionMenuOpen(int a_option)
    If(a_option == M_OID_ValidGender)
        SetMenuDialogStartIndex(validGender)
        SetMenuDialogDefaultIndex(0)
        SetMenuDialogOptions(validGenderList)
    EndIf
    
    If(a_option == M_OID_MoralityCheck)
        SetMenuDialogStartIndex(moralityCheck)
        SetMenuDialogDefaultIndex(0)
        SetMenuDialogOptions(moralityCheckList)
    EndIf

    If(a_option == M_OID_AnimOptionList)
        SetMenuDialogStartIndex(animOption)
        SetMenuDialogDefaultIndex(0)
        SetMenuDialogOptions(animTagsOptionsList)
    EndIf
endEvent


; @implements SKI_ConfigBase, Called when a menu entry has been accepted.
event OnOptionMenuAccept(int a_option, int a_index)
    If(a_option == M_OID_ValidGender)
        validGender = a_index
        SetMenuOptionValue(a_option, validGenderList[validGender])
    EndIf
    
    If(a_option == M_OID_MoralityCheck)
        moralityCheck = a_index
        SetMenuOptionValue(a_option, moralityCheckList[moralityCheck])
    EndIf

    If(a_option == M_OID_AnimOptionList)
        animOption = a_index
        SetMenuOptionValue(a_option, animTagsOptionsList[animOption])
    EndIf
endEvent


event OnOptionDefault(int a_option)
    If( a_option == S_OID_NecroChance)
        necroChance = necroChanceDefault
        SetSliderOptionValue(a_option, necroChance)
    EndIf
    
    If( a_option == S_OID_CreatureNecroChance)
        creatureNecroChance = creatureNecroChanceDefault
        SetSliderOptionValue(a_option, creatureNecroChance)
    EndIf

    If( a_option == S_OID_MultipleNecroChance)
        multipleNecroChance = multipleNecroChanceDefault
        SetSliderOptionValue(a_option, multipleNecroChance)
    EndIf
    
    If( a_option == S_OID_StartScanningTime)
        scanStartTime = scanStartTimeDefault
        SetSliderOptionValue(a_option, scanStartTime)
    EndIf

    If(a_option == S_OID_DeathCamDuration)
        deathCamDuration = deathCamDurationDefault
        SetSliderOptionValue(a_option, deathCamDuration)
    EndIf
    
    If( a_option == S_OID_EndScanningTime)
        scanEndTime = scanEndTimeDefault
        SetSliderOptionValue(a_option, scanEndTime)
    EndIf
    
    If(a_option == M_OID_ValidGender)
        validGender = validGenderDefault
        SetMenuOptionValue(a_option, validGenderList[validGender])
    EndIf
    
    If(a_option == M_OID_MoralityCheck)
        moralityCheck = moralityCheckDefault
        SetMenuOptionValue(a_option, moralityCheckList[moralityCheck])
    EndIf
endEvent

; Current Expression Getter
Function MFGGet()
    int expID = 0
    while (expID < 16)
        MfgPhonemeStrength[expID] = MfgConsoleFunc.GetPhoneme(Game.GetPlayer(), expID)
        MfgModifierStrength[expID] = MfgConsoleFunc.GetModifier(Game.GetPlayer(), expID)
        ; Reset all expression value because only 1 expression is allowed
        MfgExpression[expID] = 0
        expID += 1
    endwhile
    int expressionID = MfgConsoleFunc.GetExpressionID(Game.GetPlayer())
    int expressionValue = MfgConsoleFunc.GetPhonemeModifier(Game.GetPlayer(),2,expressionID)
    MfgExpression[expressionID] = expressionValue
endfunction

; Set Current Expression 
Function MFGSet()
    Utils.ApplyDeadExpression(Game.GetPlayer())
endfunction

; Getters! This is how the two main scripts communicate with each other. 
Bool Function GetModEnabled()
    return modEnabled
EndFunction

Function SetModEnabled(Bool value)
    modEnabled = value
    Main.RegisterForSingleUpdate(1)
EndFunction

Bool Function GetCreatureNecro()
    return creatureNecro
EndFunction

Bool Function GetCombatNecro()
    return combatNecro
EndFunction

;Bool Function GetKillerOnly()
;    return KillerOnly
;EndFunction

Bool Function GetHandleFollowers()
    return handleFollowers
EndFunction

Bool Function GetKillFollowers()
    return killFollowers
EndFunction

Bool Function GetRemoveEffects()
    return wetColdEffects
EndFunction

;Bool Function GetToggleLights()
;   return toggleLights
;EndFunction

Bool Function GetToggleMenus()
    return toggleMenus
EndFunction

Bool Function GetEBTNoBlood()
    return noBloodPools
EndFunction

Bool Function GetDoFadeout()
    return doFadeOut
EndFunction

Bool Function GetUseOldResurrection()
    return useOldResurrection
EndFunction

Bool Function GetPostNecroInstantKill()
    return postNecroInstantKill
EndFunction

Bool Function GetDeflateOnDeath()
    return deflateOnDeath
EndFunction

Bool Function GetDeflateWhenFull()
    return deflateWhenFull
EndFunction

Bool Function GetToggleFreeCam()
    return toggleFreeCam
EndFunction

;Bool Function GetToggleBlink()
;   return toggleBlinking
;EndFunction

;Bool Function GetDecorate()
;   return decorate
;EndFunction

;Bool Function GetMilkMod()
;   return MilkMod
;EndFunction

;Bool Function GetLoreResurrect()
;   return loreResurrection
;EndFunction 

int Function GetValidGender()
    return validGender
EndFunction

int Function GetMoralityCheck()
    return moralityCheck
EndFunction

int Function GetAnimOption()
    return animOption
EndFunction

float Function GetNecroChance()
    return necroChance
EndFunction

float Function SetNecroChance(float newChance)
    necroChance = newChance
EndFunction

float Function GetCreatureNecroChance()
    return creatureNecroChance
EndFunction

float Function GetMultipleNecroChance()
    return multipleNecroChance
EndFunction

float Function GetDeathCamDuration()
    return deathCamDuration
EndFunction

int Function GetScanStartTime()
    return scanStartTime
EndFunction

int Function GetScanEndTime()
    return scanEndTime
EndFunction

int Function GetKillChance()
    return KillChance
EndFunction

float Function GetKillWaitTime()
    return killWaitTime as float
EndFunction

float Function GetPostResWait()
    return PostResWait
EndFunction

bool Function GetEnableExpression()
    return enableExpression
EndFunction

int[] Function GetMfgModifierStrength()
    return MfgModifierStrength
EndFunction

int[] Function GetMfgPhonemeStrength()
    return MfgPhonemeStrength
EndFunction

int[] Function GetMfgExpression()
    return MfgExpression
EndFunction