ScriptName SexLabPlayerNecroScript extends referencealias
; Note for documentation: Most things have been commented explaining what they do. If there isn't any comment around it, the code itself should explain what it does.
; I hope anyways. I have also included notes as to why I did a thing the way I did, both for future me, and others looking at the code.

; Main properties
;Faction Property CalmFaction Auto
SexlabFramework property SexLab auto
Actor Property PlayerRef Auto
ReferenceAlias[] Property Comps Auto
ReferenceAlias[] Property Aggressors Auto
SLPGN_MCMConfig Property Settings Auto
SLPGNUtils Property Utils Auto
SLPGNActorLib Property ActorLib Auto
SLPGNAnimLib Property AnimLib Auto

import MiscUtil ; For some reason, if this is moved to the top (right below the scriptname declaration), it does not work. However here it works just fine. Please leave this line alone or I will hunt you down. ;)

; Internal variables
Actor[] actorsAround
Actor[] followersAround

Actor PlayerKiller
Actor Follower 

Bool CanLive = false

; Sure these could all be put in an array if I wanted to be efficient, but then I lose out on being able to add compatiblity for more mods in the future.
;these are just variables tracking whether or not specific mods are installed or not.
Bool WetAndColdPresent = false
Bool RAASPresent = false
Bool FHUPresent = false
Bool MilkModPresent = false
Bool DeathCamPresent = false
Int FollowerFramework = 0 ; 0 = none, 1 = NFF, 2 = AFT, 3 = EFF.
Int FacelightType = 0 ; 0 = none, 1 = Facelght, 2 = Facelight plus...
Bool EBTPresent = false ; Enhanced Blood Textures adds a script which causes blood pools on every death. Hopefully we can disable this within this mod.
Bool EBTEffectRemoved = false ; Whether or not the code that removeds the effect has been ran. More of a sanity check for a run once thing. 

int TotalDeaths = 0 ; This could have been a bool, like "first death", however I kept it an integer for future use. Maybe I might want to do something with this in the future. Perhaps a counter in the MCM?

String[] animOptions ; 0 = just the name, 1 = the name, plus a comma because one line later on uses it...the rest use just the name.

sslBaseExpression DeathExpression

; Event thingies.
Event OnInit() ; When the scripts initialise for the very first time.
    animOptions = new string[2] ; Initialise the array.
    LoadLibraries() ; And load the "libraries", or rather the other scripts.
EndEvent


Event OnPlayerLoadGame()
    ; I have it also load the libraries on every game load. Now, is this really required? No it isn't.
    ; However, I don't trust the game enough to have it set these only when the script is initialised.
    LoadLibraries() 
    
    If(!DeathCamPresent)
        ApplyDeathCamTime()
    EndIf
EndEvent


Event RefreshDeathExpression(string EventName, string argString, Float argNum, form sender) ; Refresh Death Expression Every Stage
    Actor victim = (sender as sslThreadController).VictimRef
    Utils.ApplyDeadExpressionWithoutPhoneme(victim)
    Utility.Wait(0.1)
    Utils.ApplyDeadExpressionWithoutPhoneme(victim)
EndEvent

Event StartToggleFreeCam(string EventName, string argString, Float argNum, form sender) ; togglefreecam
    Utils.DisableBlackScreen()

    Utility.Wait(1)
    if(Settings.GetToggleFreeCam())
        MiscUtil.ToggleFreeCamera(false)    
        MiscUtil.SetFreeCameraSpeed(5)
    EndIf
    
    
    Utils.ApplyDeadExpression(PlayerRef)
EndEvent

Event EndPlayerNecro(string EventName, string argString, Float argNum, form sender) ; kill that player at end of sex
    if(Settings.GetPostNecroInstantKill())
        Utils.KillPlayer()
        Utils.ApplyDeadExpression(PlayerRef)
        Utils.DoMenus()
        Return
    endIf
    
    Utils.ApplyDeadExpression(PlayerRef)
    Utils.DoMenus()

    int KillChance = Utility.RandomInt(0, 100) ;Generate a  random number between 0 and 100...

    If(KillChance >  Settings.GetKillChance()) ; If the number is greater than the chance that the player character dies after the act,
        ; Then the game has decided the player may live again, and any events we want to have happen will go here.
;        If(!Settings.GetNaturalResurrection()) ; Now, this, this will be for like "should it require a black soul gem or a dragon soul to come back to life" first.
        CanLive = true
        Utils.AddColdEffects() ; Re-add the effects we removed on death.
        Utils.AddFacelights()
        Utils.EnableBloodPools()
        EBTEffectRemoved = false
        Debug.Notification(" Somehow, you have been sexed back to life.") ; I wish to change this, but am not sure what to.
        TotalDeaths = 0 ; Reset this to zero.
;        Else
;         Utils.NaturalResurrection()
;   EndIf
    Else
        CanLive = false
    EndIf

    If(!CanLive)
        Float waittime
        If(Settings.GetKillWaitTime() > 1.0)
            waittime = Utility.RandomFloat(1.0, Settings.GetKillWaitTime()) 
        EndIf
        Utility.Wait(waittime)

        Utils.KillPlayer()
    Else
        Utility.Wait(Settings.GetPostResWait()) ; The purpose of this option is, more or less to give the player character time to escape their situation, if desired.
        Utils.UnCalmActors(actorsAround) ; After waiting the set amount of time, 
    EndIf
EndEvent

Event OnStartFollowerNecro(string EventName, string argString, Float argNum, form sender) ; kill that follower
    Actor victim = (sender as sslThreadController).VictimRef
    
    ; Followers expression reset when playing scene, reapply again
    Utils.ApplyDeadExpression(victim)
EndEvent


Event EndFollowerNecro(string EventName, string argString, Float argNum, form sender) ; kill that follower
    Actor victim = (sender as sslThreadController).VictimRef
    Utils.KillFollower(victim)
EndEvent


; Functions begin.
function OnDying(actor akKiller)
    If(Settings == NONE)
        Settings = Game.GetFormFromFile(0x22ED, "SLPGN.esp") as SLPGN_MCMConfig
    EndIf

    ; Nullcheck, basically.
    if (akKiller != none)
        PlayerKiller = akKiller
    endIf

;   It's basically a null check.
   If(animOptions.Length == 0)
        animOptions = new string [2]
    EndIf

    CanLive = false
    if (PlayerRef.isDead() || PlayerRef.GetActorValue("Health") <= 0.0)
        ; Any event that we want to happen on player death, every death goes here. 
        TotalDeaths +=1
        
        animOptions = AnimLib.CheckAnimOption(animOptions)
        Utils.RemoveColdEffects()
        Utils.RemoveFacelights()
        Utils.FullDeflateCheck()

        If(TotalDeaths == 1)
            ; And any event we want to happen only on the initial death that fires off the mod for the first time goes here.
            Log("Player is now dead. Beginning the mod's main thing.")
            Utils.KillFollowers()
            Utils.DeflateCheck()
        EndIf
        
        ; Applying Death Expression here after Follower check because death expression have delay and in turn delaying follower kill function
        Utils.ApplyDeadExpression(PlayerRef)
        DeathExpression = Utils.RegisterDeadExpression()
        

        If (!Settings.GetModEnabled())
            return 
        endIf
        
        RandomTrigger() ; This was moved here 
    EndIf
endFunction


function OnUpdate()
    ;If (PlayerRef.isDead() || PlayerRef.GetActorValue("Health") <= 0.0) ; Sanity check for health, basically.
        If (!Settings.GetModEnabled())
            return 
        endIf
        
        actorsAround = ActorLib.GetNearbyActors(actorsAround, Aggressors)
        Actor[] possibleActors = ActorLib.ValidNecroActorCheck(actorsAround)

        if (possibleActors.find(NONE) == 0)
            Debug.Notification("No Valid Actor")
            RandomTrigger()
            return 
        endIf
        
        Actor[] sexActors = ActorLib.SelectActorsToPlay(PlayerRef, possibleActors)
        
        if (sexActors.length < 2)
            Debug.Notification("Too Few Actor")
            RandomTrigger()
            return 
        endIf
        
        ; Player chance check
        If (PlayerRef.isDead() || PlayerRef.GetActorValue("Health") <= 0.0) ; Sanity check for health, basically.
            if (Utility.RandomFloat(0.0, 100.0) < Settings.GetNecroChance())
                Utils.EnableBlackScreen()
                
                Utils.CalmActors(PlayerRef, actorsAround)
                StartPlayerNecro(sexActors)
            endIf
            Utility.Wait(1)
        EndIf

        ; Follower chance check
        If(Settings.GetHandleFollowers())
            FollowerCheck(possibleActors, sexActors)
        EndIf
        
        ;EndIf
    RandomTrigger()
endFunction


Function StartPlayerNecro(Actor[] sexActors)
    sslBaseAnimation[] anims = AnimLib.SetNecroAnims(sexActors, animOptions)
    sslThreadModel thread = SexLab.NewThread()
    
    Utils.ResurrectPlayer()
    If(!EBTEffectRemoved)
        Utils.DisableBloodPools() ; This is here instead of in the on death function because the blood pooling was getting disabled on the first death before it could even happen otherwise.
        EBTEffectRemoved = true
    EndIf
        
    thread.AddActors(sexActors, sexActors[0])

    sslbasevoice ToVoice = SexLab.GetVoice(PlayerRef)
    thread.SetVoice(PlayerRef, ToVoice, true)
    thread.DisableBedUse()
    thread.SetExpression(PlayerRef, DeathExpression)

    thread.SetAnimations(anims)
    Utils.ApplyDeadExpression(PlayerRef)
    RegisterForModEvent("AnimationStart_SLPNHook", "StartToggleFreeCam")
    RegisterForModEvent("StageStart_SLPNHook", "RefreshDeathExpression")
    
    If(Settings.GetPostNecroInstantKill())
        RegisterForModEvent("AnimationEnding_SLPNHook", "EndPlayerNecro")
    Else
        RegisterForModEvent("AnimationEnding_SLPNHook", "RefreshDeathExpression")
        RegisterForModEvent("AnimationEnd_SLPNHook", "EndPlayerNecro")
    EndIf
    
    thread.SetHook("SLPNHook")

    thread.DisableRagdollEnd(None, true)
    thread.DisableRagdollEnd(PlayerRef, false)
    sslthreadcontroller ThreadCon = thread.StartThread()


    log("Attempting to Necro player corpse.")

    if (!ThreadCon)
        log("Necro attempt failed!")
        Utils.DisableBlackScreen()
        Utils.KillPlayer()
    endIf
EndFunction




Function StartFollowerNecro(Actor selectedFollower, Actor[] sexActors)
    sslBaseAnimation[] anims = AnimLib.SetNecroAnims(sexActors, animOptions)
    sslThreadModel followerNecroThread = SexLab.NewThread()
    
    
    Utils.ResurrectFollower(selectedFollower)
    
    ; Followers expression reset when resurrected, reapply again
    Utils.ApplyDeadExpression(selectedFollower)

    followerNecroThread.AddActors(sexActors, sexActors[0])

    sslbasevoice ToVoice = SexLab.GetVoice(selectedFollower)
    followerNecroThread.SetVoice(selectedFollower, ToVoice, true)
    followerNecroThread.DisableBedUse()
    followerNecroThread.SetExpression(selectedFollower, DeathExpression)

    followerNecroThread.SetAnimations(anims)
    RegisterForModEvent("AnimationStart_SLPNHookFollower", "OnStartFollowerNecro")
    RegisterForModEvent("StageStart_SLPNHookFollower", "RefreshDeathExpression")

    followerNecroThread.SetHook("SLPNHookFollower")
    
    If(Settings.GetPostNecroInstantKill())
        RegisterForModEvent("AnimationEnding_SLPNHookFollower", "EndFollowerNecro")
    Else
        RegisterForModEvent("AnimationEnding_SLPNHookFollower", "RefreshDeathExpression")
        RegisterForModEvent("AnimationEnd_SLPNHookFollower", "EndFollowerNecro")
    EndIf

    followerNecroThread.DisableRagdollEnd(None, true)
    followerNecroThread.DisableRagdollEnd(selectedFollower, false)
    sslthreadcontroller followerNecroThreadCon = followerNecroThread.StartThread()
    log("Attempting to Necro follower corpse.")

    if (!followerNecroThreadCon)
        log("Follower Necro attempt failed!")
        Utils.KillFollower(selectedFollower)
    endIf
EndFunction


Function FollowerCheck(Actor[] possibleActors, Actor[] sexActors)
    Actor[] deadFollowers = ActorLib.GetDeadFollowers(followersAround, Comps)   
    int i = 0
    
    int followerCount = 0
    If(deadFollowers.Find(None) > 0) ; Check if there is any follower
        followerCount = deadFollowers.Find(None) 
    ElseIf (deadFollowers.Find(None) == -1) ; Check if there are maximum number of followers allowed, currently hardcoded to 10
        followerCount = deadFollowers.Length
    Else  ; No dead follower detected, no necro segs
        return
    EndIf
    
    While (i < followerCount)
        Follower = deadFollowers[i]
        
        if (Utility.RandomFloat(0.0, 100.0) < Settings.GetNecroChance())
            actorsAround = ActorLib.GetNearbyActors(actorsAround, Aggressors)
            Utils.CalmActors(Follower, actorsAround)
            
            possibleActors = ActorLib.ValidNecroActorCheck(actorsAround) ;#2
            if (possibleActors.find(NONE) == 0)
                return 
            endIf

            sexActors = ActorLib.SelectActorsToPlay(Follower, possibleActors) ; #3
            if (sexActors.length < 2)
                return 
            endIf
            
            StartFollowerNecro(Follower, sexActors) ; #4
            Utility.Wait(1)
        EndIf
        
        i += 1
    EndWhile
EndFunction


; Generate a number between the lower bound (set by scan start time) and upper bound (set by scan end time), then register for a single update after this amount of time.
; Register for update, essentially tells the game "after x amount of time, call any function in the script titled "OnUpdate()", and only call it once."
Function RandomTrigger()
    int nextAttempt = Utility.RandomInt(Settings.GetScanStartTime(), Settings.GetScanEndTime())
    RegisterForSingleUpdate(nextAttempt)
EndFunction


; If there is no death camera mod installed, this is called / used.
Function ApplyDeathCamTime()
    Game.SetGameSettingFloat("fPlayerDeathReloadTime", Settings.GetDeathCamDuration())
EndFunction
 
; --------------------------------- Sanity checks because Papyrus is stupid as hell sometimes. -----------------------------------------------------------

Function LoadLibraries()
    Form SLPGNQuest = Game.GetFormFromFile(0xD62, "SLPGN.esp") ; Note to future me: If I ever do a plugin compaction (for light plugin usage), this value should be fine, but double check.


    Log("Loading Libraries...")
    If(SLPGNQuest)
        Settings = Game.GetFormFromFile(0x22ED, "SLPGN.esp") as SLPGN_MCMConfig ; This will for sure need to be updated if I do a compaction.
        ActorLib = SLPGNQuest as SLPGNActorLib

        AnimLib.LoadLibraries()
        ActorLib.LoadLibraries()
        Utils.LoadLibraries()
        Utils.ModChecks()
    Else
        Log("For some inane reason, the game failed to find the main quest of this very mod. Things will not work if this happens.") 
    EndIf
EndFunction



;------------------------------------ Debug Stuff -----------------------------

Function log(String argString)
    Debug.Trace("SLPGN: " + Utility.GetCurrentRealTime()+ " -- " + argString )  
EndFunction


; --------------------------------- Good old getters and setters. No further explanation needed. ---------------------------------------------------------
Actor[] Function GetActorsAround()
        return actorsAround
EndFunction

String[] Function GetAnimOptions()
    return animOptions
EndFunction

Function SetRAASPresent(Bool modExists)
    RAASPresent = modExists
EndFunction

Bool Function GetRAASPresent()
    return RAASPresent
EndFunction

Function SetWetAndColdPresent(Bool modExists)
    WetAndColdPresent = modExists
EndFunction

Bool Function GetWetAndColdPresent()
    return WetAndColdPresent
EndFunction

Function SetFHUPresent(Bool modExists)
    FHUPresent = modExists
EndFunction

Bool Function GetFHUPresent()
    return FHUPresent
EndFunction

Function SetMilkModPresent(Bool modExists)
    MilkModPresent = modExists
EndFunction

Bool Function GetMilkModPresent()
    return MilkModPresent
EndFunction

Function SetDeathCamPresent(bool Cam)
    DeathCamPresent = Cam
EndFunction

Bool Function GetDeathCamPresent()
    return DeathCamPresent
EndFunction

Function SetEBTPresent(bool EBT)
    EBTPresent = EBT
EndFunction

Bool Function GetEBTPresent()
    return EBTPresent
EndFunction

Int Function GetFacelightType()
    return FacelightType
EndFunction

Function SetFacelightType(Int type)
    FacelightType = type
EndFunction

Int Function GetFollowerFramework()
    return FollowerFramework
EndFunction

Function SetFollowerFramework(Int framework)
    FollowerFramework = framework
EndFunction